SystemOrganization addCategory: #'TP1-TADP-2013-1c-G6'!

Trait named: #TComputadora
	uses: {}
	category: 'TP1-TADP-2013-1c-G6'!

!TComputadora methodsFor: 'metodos' stamp: 'aye 4/16/2013 23:12'!
dameConsumo
^self partes inject: 0 into: [:acum :unaParte | acum + unaParte dameConsumo]! !

!TComputadora methodsFor: 'metodos' stamp: 'aye 4/16/2013 23:37'!
esAptaParaJugarVideojuegos
^self partes allSatisfy: [:unaParte | unaParte esAptaParaJugar]! !

!TComputadora methodsFor: 'constructor' stamp: 'aye 4/16/2013 23:09'!
nueva
"Hacemos una Computadora Nueva con su Set instanciado"
	 | nuevaComputadora |
	
	nuevaComputadora := self new.
	nuevaComputadora partes: Set new.
	^nuevaComputadora! !

Trait named: #TConsumoAleatorio
	uses: {}
	category: 'TP1-TADP-2013-1c-G6'!

!TConsumoAleatorio methodsFor: 'as yet unclassified' stamp: 'Gonzalo 4/16/2013 02:34'!
dameConsumoCon: unaPantalla
^self wattsPorHora * unaPantalla dameDefinicionMax.! !

!TConsumoAleatorio methodsFor: 'as yet unclassified' stamp: 'Gonzalo 4/16/2013 02:25'!
wattsPorHora
self requirement
! !

Trait named: #TConsumoCoolers
	uses: {}
	category: 'TP1-TADP-2013-1c-G6'!

!TConsumoCoolers methodsFor: 'self requirement' stamp: 'aye 4/16/2013 23:53'!
cantCoolers self requiment ! !

!TConsumoCoolers methodsFor: 'methods' stamp: 'aye 4/16/2013 23:52'!
dameConsumoCoolers
^self cantCoolers * 0.5 ! !

Trait named: #TConsumoPlacaClasica
	uses: {}
	category: 'TP1-TADP-2013-1c-G6'!

!TConsumoPlacaClasica methodsFor: 'metodosPropios' stamp: 'aye 4/16/2013 23:44'!
dameConsumo
^self wattPorHora + self dameConsumoCoolers.! !

!TConsumoPlacaClasica methodsFor: 'metodosPropios' stamp: 'aye 4/16/2013 23:47'!
dameConsumoCoolers
! !

!TConsumoPlacaClasica methodsFor: 'selfRequirements' stamp: 'aye 4/16/2013 23:46'!
wattPorHora self requiment! !

Trait named: #TConsumoPlacaModerna
	uses: TConsumoAleatorio
	category: 'TP1-TADP-2013-1c-G6'!

TConsumoPlacaModerna classTrait
	uses: TConsumoAleatorio classTrait!

!TConsumoPlacaModerna methodsFor: 'methods' stamp: 'aye 4/17/2013 00:21'!
dameConsumo
	^self dameConsumoCon: self pantalla + self dameConsumoCoolers! !

!TConsumoPlacaModerna methodsFor: 'selfRequirements' stamp: 'aye 4/17/2013 00:22'!
dameConsumoCoolers self requiment ! !

!TConsumoPlacaModerna methodsFor: 'selfRequirements' stamp: 'aye 4/17/2013 00:21'!
pantalla self requiment ! !

Trait named: #TConsumoPorcentual
	uses: {}
	category: 'TP1-TADP-2013-1c-G6'!

!TConsumoPorcentual methodsFor: 'as yet unclassified' stamp: 'Gonzalo 4/16/2013 02:30'!
dameConsumoCon: unaPantalla
^self porcentaje * unaPantalla dameConsumoPropio / 100.! !

!TConsumoPorcentual methodsFor: 'as yet unclassified' stamp: 'Gonzalo 4/16/2013 02:31'!
porcentaje
self requirement! !

Trait named: #TConsumoRigido
	uses: {}
	category: 'TP1-TADP-2013-1c-G6'!

!TConsumoRigido methodsFor: 'methods' stamp: 'aye 4/17/2013 00:36'!
dameConsumo
^ self esMagnetico ifTrue: [self rpm * self wattPorHora/ self wattPorHora]
     ifFalse: [self wattPorHora]! !

!TConsumoRigido methodsFor: 'self requirement' stamp: 'aye 4/17/2013 00:36'!
esMagnetico self requiment ! !

!TConsumoRigido methodsFor: 'self requirement' stamp: 'aye 4/17/2013 00:37'!
rpm self requiment ! !

!TConsumoRigido methodsFor: 'self requirement' stamp: 'aye 4/17/2013 00:37'!
wattPorHora self requiment ! !

Trait named: #TPlacaClasica
	uses: {}
	category: 'TP1-TADP-2013-1c-G6'!

!TPlacaClasica methodsFor: 'selfRequirements' stamp: 'aye 4/17/2013 00:04'!
dameConsumo self requiment ! !

!TPlacaClasica methodsFor: 'selfRequirements' stamp: 'aye 4/16/2013 23:50'!
dameConsumoCoolers self requirement
! !

!TPlacaClasica methodsFor: 'metodosPropios' stamp: 'aye 4/17/2013 00:02'!
esAptaParaJugar
^ self esOnBoard not and:  (self pantalla) / self dameConsumo > 4! !

!TPlacaClasica methodsFor: 'selfRequirements' stamp: 'aye 4/17/2013 00:03'!
esOnBoard self requiment ! !

!TPlacaClasica methodsFor: 'selfRequirements' stamp: 'aye 4/17/2013 00:03'!
pantalla self requiment ! !

!TPlacaClasica methodsFor: 'selfRequirements' stamp: 'aye 4/16/2013 23:46'!
wattPorHora self requiment! !

Trait named: #TSiemprePuedeJugar
	uses: {}
	category: 'TP1-TADP-2013-1c-G6'!

!TSiemprePuedeJugar methodsFor: 'methods' stamp: 'aye 4/17/2013 00:27'!
esAptaParaJugar
^true! !

Trait named: #TTasaRefresco
	uses: {}
	category: 'TP1-TADP-2013-1c-G6'!

!TTasaRefresco methodsFor: 'as yet unclassified' stamp: 'Gonzalo 4/16/2013 01:52'!
dameTasaRefresco
"retorna la tasa refresco"
^self tasaRefresco! !

!TTasaRefresco methodsFor: 'as yet unclassified' stamp: 'Gonzalo 4/16/2013 02:00'!
tasaRefresco
self requirement! !

Object subclass: #Computadora
	uses: TComputadora
	instanceVariableNames: 'partes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-TADP-2013-1c-G6'!

Computadora class
	uses: TComputadora classTrait
	instanceVariableNames: ''!

!Computadora class methodsFor: 'constructor' stamp: 'aye 4/16/2013 22:49'!
nueva! !

!Computadora methodsFor: 'metodos' stamp: 'aye 4/16/2013 23:04'!
partes: unConjuntoDePartes
	self.partes := unConjuntoDePartes.

! !

Object subclass: #DiscoRigido
	uses: TSiemprePuedeJugar
	instanceVariableNames: 'wattPorHora rpm esMagnetico'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-TADP-2013-1c-G6'!

DiscoRigido class
	uses: TSiemprePuedeJugar classTrait
	instanceVariableNames: ''!

Object subclass: #Entrada
	uses: TTasaRefresco
	instanceVariableNames: 'definicion tasaRefresco'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-TADP-2013-1c-G6'!

Entrada class
	uses: TTasaRefresco classTrait
	instanceVariableNames: ''!

!Entrada methodsFor: 'accessing' stamp: 'Gonzalo 4/16/2013 01:58'!
definicion
	^ definicion! !

!Entrada methodsFor: 'accessing' stamp: 'Gonzalo 4/16/2013 01:58'!
definicion: anObject
	definicion := anObject! !

!Entrada methodsFor: 'accessing' stamp: 'Gonzalo 4/16/2013 01:58'!
tasaRefresco
	^ tasaRefresco! !

!Entrada methodsFor: 'accessing' stamp: 'Gonzalo 4/16/2013 01:58'!
tasaRefresco: anObject
	tasaRefresco := anObject! !

Entrada subclass: #EntradaModerna
	uses: TConsumoPorcentual
	instanceVariableNames: 'porcentaje'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-TADP-2013-1c-G6'!

EntradaModerna class
	uses: TConsumoPorcentual classTrait
	instanceVariableNames: 'tasaRefresco'!

EntradaModerna class
	uses: TConsumoPorcentual classTrait
	instanceVariableNames: 'tasaRefresco'!

EntradaModerna subclass: #AV
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-TADP-2013-1c-G6'!

!EntradaModerna methodsFor: 'accessing' stamp: 'Gonzalo 4/16/2013 02:13'!
porcentaje
	^ porcentaje! !

!EntradaModerna methodsFor: 'accessing' stamp: 'Gonzalo 4/16/2013 02:13'!
porcentaje: anObject
	porcentaje := anObject! !

EntradaModerna subclass: #HDMI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-TADP-2013-1c-G6'!

EntradaModerna subclass: #RF
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-TADP-2013-1c-G6'!

!RF methodsFor: 'as yet unclassified' stamp: 'Gonzalo 4/16/2013 02:40'!
dameConsumoCon: unaPantalla
"No conviene setear el porcentaje en 0 ? y que el dame consumo haga  ^porcentaje.   xq sino tiene esa variable al re pedo.."
^0.! !

Entrada subclass: #VGA
	uses: TConsumoAleatorio
	instanceVariableNames: 'wattsPorHora'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-TADP-2013-1c-G6'!

VGA class
	uses: TConsumoAleatorio classTrait
	instanceVariableNames: ''!

!VGA methodsFor: 'accessing' stamp: 'Gonzalo 4/16/2013 02:08'!
wattsPorHora
	^ wattsPorHora! !

!VGA methodsFor: 'accessing' stamp: 'Gonzalo 4/16/2013 02:08'!
wattsPorHora: anObject
	wattsPorHora := anObject! !

Object subclass: #PlacaDeVideo
	uses: TConsumoCoolers
	instanceVariableNames: 'wattPorHora definicion cantCoolers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-TADP-2013-1c-G6'!

PlacaDeVideo class
	uses: TConsumoCoolers classTrait
	instanceVariableNames: ''!

PlacaDeVideo subclass: #Clasica
	uses: TPlacaClasica - {#dameConsumoCoolers}
	instanceVariableNames: 'esOnBoard pantalla'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-TADP-2013-1c-G6'!

Clasica class
	uses: TPlacaClasica classTrait
	instanceVariableNames: ''!

PlacaDeVideo subclass: #Moderna
	uses: TConsumoPlacaModerna - {#pantalla}
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-TADP-2013-1c-G6'!

Moderna class
	uses: TConsumoPlacaModerna classTrait
	instanceVariableNames: ''!
